#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <stdio.h>

unsigned char RXD;
unsigned int chnel;


static int USART0_putchar(char c, FILE *stream);
static FILE device = FDEV_SETUP_STREAM(USART0_putchar, NULL, _FDEV_SETUP_WRITE);
 
void MCU_initialize(void)				
{ 

  DDRB = 0xf0;							

  DDRD = 0xF8;							   
  PORTD = 0x00;


  UBRRH = 0;                                  
  UBRRL = 35; //19200 bps,  71=>9600bps, 23=>28800bps, 17=>38400bps, 11=>57600bps

 
  UCSRA = 0x00;                        	// 00  asynchronous normal mode
  UCSRB = 0x18;                        	// 10   Rx/Tx enable, 8 data
  UCSRC = 0x06;                        	// 86   no parity, 1 stop, 8 data                         // no parity, 1 stop, 8 data


// UCSRC=(1<<URSEL)|(1<<UCSZ0)|(1<<UCSZ1);  0001 0110
//	UCSRB=(1<<RXEN)|(1<<TXEN); 
//	UCSRA=(1<<U2X); 


}


static int USART0_putchar(char c, FILE *stream)	/* print a character to USART0 */
{
  if(c == '\n')                                 // process CR(carriage return)
    { loop_until_bit_is_set(UCSRA,UDRE);
      UDR = 0x0D;
      loop_until_bit_is_set(UCSRA,UDRE);
      UDR = 0x0A;
    }
  else
    { loop_until_bit_is_set(UCSRA,UDRE);	// Tx ready ?
      UDR = c;					// if yes, print
    }
  return 0;
}

void Delay_us(unsigned char time_us)	
{ register unsigned char i;

  for(i = 0; i < time_us; i++)			// 4 cycle +
    { asm volatile(" PUSH  R0 ");		// 2 cycle +
      asm volatile(" POP   R0 ");		// 2 cycle +
      asm volatile(" PUSH  R0 ");		// 2 cycle +
      asm volatile(" POP   R0 ");		// 2 cycle = 16 cycle = 1 us 
    }
}

void Delay_ms(unsigned int time_ms)	
{ register unsigned int i;

  for(i = 0; i < time_ms; i++)
    { Delay_us(250);
      Delay_us(250);
      Delay_us(250);
      Delay_us(250);
    }
}
unsigned char RX0_char_scan(void)		/* receive a character by USART0 */
{
  if((UCSRA & 0x80) == 0x00)   		// if data not received,
    return 0x00;                                //    return with 0x00
  else                                          // if data received,
    return UDR;                                //    return with data
}

unsigned char RX0_char(void)		        /* receive a character by USART0 */
{
  while((UCSRA & 0x80) == 0x00);		// data received ?
  return UDR;
}


void TX0_char(unsigned char byte)		/* 1 byte transmit a character by USART0 */
{
  while((UCSRA & 0x20) == 0x00);		// data register empty ?
  UDR = byte;
}

void send(void)
{
TX0_char('\n');
TX0_char('\r');

}

void TX0_string(char *string)			// transmit a string by USART0 
{
  while(*string != '\0')
    { TX0_char(*string);
       string++;
    }
}



int main(void)
{ 
 	MCU_initialize();                    	// initialize MCU
  
	Delay_ms(100);    
	TX0_string("ATtiny2313 Board Test\n");
 	Delay_ms(500);
		while(1) {
 
    RXD = RX0_char_scan();
switch(RXD)
  {
	case 'a':
	case 'A':
	TX0_string("Uart Test => Keyboard A \n");
		break;
	case 'b':
	case 'B':
	TX0_string("Uart Test => Keyboard B \n");
    	break;
	
	default:
	
	break;
	}

	  
	} //while
   return 0;
   
 } //main




